﻿Imports System.Collections.Generic
Imports System.Linq
Imports System.Text
Imports DomainModel
Imports IdeaBlade.EntityModel
Imports System.ComponentModel

Namespace WpfApplication1
    Class MainWindowViewModel
        Implements INotifyPropertyChanged
#Region "Constructor"
        Public Sub New()
        End Sub
#End Region

#Region "Methods"
        Public Sub Start()
            FirstSample()
        End Sub

        Public Sub FirstSample()
            Dim aStringBuilder As New StringBuilder("Started FirstSample()..." & vbCrLf)

            Dim customersQuery = From cust In _mgr.Customers _
               Where cust.ContactTitle = "Sales Representative" _
               Order By cust.CompanyName _
             Select cust

            aStringBuilder.Append(String.Format("Retrieved {0} customers" & vbLf, customersQuery.ToList().Count))

            For Each aCustomer As Customer In customersQuery
                aStringBuilder.Append(String.Format("Customer: {0}" & vbLf, aCustomer.CompanyName))
            Next

            Output = aStringBuilder.ToString()
        End Sub

#End Region
#Region "Data Bound Properties"
        Public Property Output() As String
            Get
                Return _output
            End Get
            Set(ByVal value As String)
                _output = value
                RaisePropertyChanged("Output")
            End Set
        End Property
#End Region


#Region "INotifyPropertyChanged"
        Public Event PropertyChanged As PropertyChangedEventHandler Implements INotifyPropertyChanged.PropertyChanged

        Protected Sub RaisePropertyChanged(ByVal propertyName As String)
            RaiseEvent PropertyChanged(Me, New PropertyChangedEventArgs(propertyName))
        End Sub
#End Region

#Region "Private Fields"
        Private _mgr As New NorthwindIBEntityManager()
        Private _output As String = ""
#End Region

    End Class
End Namespace
